#ifndef __GoGoBoardLib__
#define __GoGoBoardLib__

#include <Arduino.h>

// #define GOGOBRIGHT_I2C_ADDRESS 0x42
#define GOGOBOARD_TX 9
#define GOGOBOARD_RX 10

#define LED_ON true
#define LED_OFF false

class GoGoBoardLib
{
private:
  uint8_t pinNumber;
  int numberMotor[4] = {0, 0, 0, 0};
  int numberServo[4] = {0, 0, 0, 0};
  uint8_t oledText [4];
  uint8_t gblSSID[];
  uint8_t gblPWD[];

  uint8_t stmBuffer[];

  int setMotorForSentPkt(int *num);
  uint8_t checkSumPkt(uint8_t *pkt);
  void gogoSendPkt(uint8_t *a);
  void setSelectMotorServo(int numSelect, int mode);
  void clearMotorServo(int numSelect, int mode);
  void convertTextForSend(char *);
public:
  GoGoBoardLib(void);
  ~GoGoBoardLib(void);

  void begin(void);

  void modeBegin(int pin);

  void motor_Select(int number);
  void motor_OnOff(char *mode);
  void motor_Turn(char *mode);
  void motor_Reverse(void);
  void motor_Break(void);
  void motor_SetPower(int val);
  void motor_Toggle(int val);
  void motor_SetServo(int val);

  void run_LED(int status);
  void beep(void);
  void logo_Control(int number);
  void servo_Select(int number);
  void servo_ThisWay(int val);
  void servo_ThatWay(int val);
  void servo_Angle(int val);
  void servo_Toggle(int servoNumber);
  void show_Text(char *text);

  void reboot(void);
  void readReg(int);
  void config_Wifi(int,int,char*,char*);

  void blink(bool status);                  //enable blinking with 1s duration
  void blink(bool status, int blinkLength); //enable blinking with blink duration
};

class GoGoBoard : public GoGoBoardLib
{
};

#endif